<?php
//textes
define("TITLE","Simulation of a search engine");

define("LEVEL","Level:");
define("LEVEL1","Beginner (10-12 years old)");
define("LEVEL2","Medium (13-15 years old)");
define("LEVEL3","Advanced (16-18 years old)");
define("MODE","Mode:");
define("MODE1","In the schoolroom (2 hours)");
define("MODE2","In the schoolroom (1 hour)");
define("MODE3","Autonomy");

define("INDEX1","Let's imagine..."); 
define("INDEX2","that there are only 10 pages on the web!");

define("INTRO1","<h1>While there are only a few pages on the web, John Smith has a very good idea.<br>He creates a <i>search engine</i> called <b>Webfinder</b>! so that we can navigate the web.</h1>");
define("INTRO2","<p>Little by little, he will make his <i>search engine</i> more complicated.<br>Let's follow the evolutions!</p>");
define("MENTIONS1","Legal notice");
define("MENTIONS2","<p style=\"text-align:justify;font-size:1em;\">Online simulation realized by Florian Reynaud, professor documentalist, under license <a href=\"http://www.gnu.org/licenses/agpl.html\" style=\"display:inline;\" title=\"AGPL (GNU)\">AGPL</a>. Version 2.6. February 1th, 2019. Navigation icons created by <a href=\"http://www.flaticon.com/authors/dave-gandy\" title=\"Dave Gandy\">Dave Gandy</a> on <a href=\"http://www.flaticon.com\" title=\"Flaticon\">www.flaticon.com</a> under license <a href=\"http://creativecommons.org/licenses/by/3.0/\" title=\"Creative Commons BY 3.0\">CC BY 3.0</a>. End icon created by <a href=\"http://www.freepik.com\" title=\"Freepik\">Freepik</a> on <a href=\"http://www.flaticon.com\" title=\"Flaticon\">www.flaticon.com</a> under license <a href=\"http://creativecommons.org/licenses/by/3.0/\" title=\"Creative Commons BY 3.0\">CC BY 3.0</a>. In this simulation, all numerical data are false.</p>");

define("REVENIR","back");
define("CONTINUER","continue");
define("SEARCH","Search...");
define("VERIF","Check");
define("VALID","Validate");
define("TRYAGAIN","Try again!");
define("TRYAGAIN1","That's okay for the first one, not for the second one.");
define("TRYAGAIN2","That's okay for the second one, not for the first one.");

define("M0INSTRU1","To begin, consult the WebFinder <b>database</b>, in the table below,<br>which contains the ten web pages:");
define("M0INSTRU2","Here's what's in the database,<br>with one page per line:");
define("M1INSTRU1","All existing pages deal with digestion.");
define("M1INSTRU2","Now, try to search for <b>digestion</b> on the search engine..");

define("BDD","Database:");
define("RESULT","Search results");
define("ERROR","There is no result with the keywords you have typed.<br> * <br> Remember that there are only ten web pages,<br>and that it is a simulation, not a real search engine! <br /> * <br>Do try again a search about <b> digestion</b>");

define("REQUETE","As a reminder, you typed ");
define("OBSERV","Observe the results (in the left side).");
define("OBSERV1","Observe the database. According to you,");
define("OBSERV2","how are the 10 results ranked?");
define("OBSERV3","what are the <b>two items</b> taken into account in the ranking of the results?");
define("OBSERV4","what are the <b>three items</b> taken into account in the ranking of the results?");
define("OBSERV5","Which item is the most important, in case of page rank equality?");
define("TRI1","You can sort each column by clicking on its title.");
define("TRI2","To sort two or three columns at the same time, sort one column then press SHIFT<br>while clicking on the new column you want to sort.");

define("CRITERE1","The addition of keywords (relevance).");

define("TABHEADER0","<th>Title of the webpage<br>(&lt; title &gt;)</th><th>URL address</th><th>Text</th><th>Number of links, on the Web, to this page</th>");
define("TABHEADER1","<th>Number of words in lemma \"digestion\" in text</th>");
define("TABHEADER2","<th>Score for hits</th>");
define("TABHEADER3","<th>Score for words</th><th>Page Rank</th>");
define("TABHEADER4","<th>Number of hits on this page</th>");
define("TABHEADER5","<th>Score for links</th>");
define("TABHEADER6","<th>Rights</th>");

define("CHECK1","word"); //for keywords
define("CHECK2","relev"); //for relevance
define("CHECK3","hit"); //for hits
define("CHECK4","popula"); //for popularity
define("CHECK5","link"); // for links
define("CHECK6","notori"); //for notoriety
define("CHECK7","+"); // pour addition, en testant aussi check1 et check3
define("CHECK8","digestion on Wikip");
define("CHECK9","Ad");
define("CHECK10","rights");
define("CHECK11","how long does it");

define("SOLUCE","Solution:");
define("SOLUCE1","<p class=\"border_blue\">The pages are classified by number of words of the <i>lemma</i> digestion<br><span style=\"font-size:0.8em;\">(which includes digestion, digestive, all the conjugations of the verb digerate, etc.)</span><br>*<br>It is a method to give <b>relevance</b> to results<br>(to respond to the user's request, according to his <b>keywords</b>).</p>");
define("SOLUCEOUBLI","<p class=\"border_blue\">A \"Rights\" column is used to check whether there is the right to integrate each page in the results (1) or not (0).<br><span style='font-size:0.7em;'>An <b>algorithm</b> does select (SELECT), in the webpages table (FROM webpages),<br>pages with right (WHERE rights = 1)<br>It gives the code: <span style = 'color:blue;'>&#36;results </span> = <span style = 'color:blue;'>&#36;bdd</span>->query(<span style='color:green;'>\"SELECT * FROM webpages WHERE rights = 1\"</span>);<br>The page without right is: ");
define("SOLUCE2","<p class=\"border_blue\">The pages are ranked according to the number of times<br>the same word is repeated throughout the page<br>but also by how many hits the page got.<br>*<br>So the pages are ranked by <b>relevance</b> (number of words)<br>and <b>popularity</b> (number of hits).<br>*<br>The repetition of words in a page gives the page a <b>score</b>,<br>the hits give a second score.<br>The <b>Page Rank</b> is generated from these scores.</p>");
define("SOLUCEALGO","<p class=\"border_blue\" style='text-align:left;'>page_rank = score_words+score_hits<br>&nbsp;<br><span style='font-size:0.8em;'><b>In details:</b><br><span style='color:blue;'>&#36;results</span> [prepares the list of pages]<br> = <span style='color:blue;'>&#36;bdd</span>->query [makes a query in database]<br>(<span style='color:green;'>\"SELECT</span> [do select :]<br><span style='color:green;'>title,</span> [title]<br><span style='color:green;'>url,</span> [url to create la link]<br><span style='color:green;'>SUBSTR(url,1,55),</span> [the beginning of the URL, <b>first 55 characters</b>]<br>span style='color:green;'>SUBSTR(text,1,300)</span> [the beginning of the page text]<br><span style='color:green;'>FROM webpages</span> [in the webpages table]<br><span style='color:green;'>ORDER BY (score_words+score_hits)</span> [<b>according to the page rank</b>]<br><span style='color:green;'>DESC,</span> [<b>from the largest to the smallest</b>]<br><span style='color:green;'>score_words DESC\"</span>); [according to the number of words in case of equalities]</span>");
define("SOLUCE3","<table class='border_blue'><tr><td colspan='2'>The pages are classified by:<br>&nbsp; <br>&nbsp; <br><ul style=\"text-align:left;margin-left:100px;\"><li>the number of words of the lemma \"digestion\" (<b>relevance</b>)</li><li>the number of hits (<b>popularity</b>)</li><li>and the number of links from other web pages (<b>notoriety</b>).</li></ul>*<br>For each addition, it establishes a <b>score</b>.<br>The <b>Page Rank</b> is generated from all scores.</td></tr></table>");
define("SOLUCEINDEX","<p class=\"border_blue\">The page in question is named <b>\"Digestion on Wikipedia\"</b>.<br>This is the <b>copy of a Wikipedia article</b>.<br>*<br>If you consult the source code of the page,<br>you can notice that it is constituted only with the <b>HTML language</b> and that a line of code specifies to the robots not to index the page:<br><span style='color:blue;'>&lt;meta</span> <span style='color:red;'>name</span>=<span style='color:green;'>\"robots\"</span> <span style='color:red;'>content</span>=<span style='color:green;'>\"noindex\"</span> <span style='color:blue;'>/&gt;</span></p>");
define("SOLUCEPUB","<p class=\"border_blue\">It is recognized that there is an advertisement with the term <b>Ad</b>.<br>The advertising link leads us to a <b>commercial site</b>.</p>");

define("NEXT","Let's move on!");
define("NEXT1","<p class=\"border_red\">John Smith thinks he has to improve the search engine.<br>Ranking the results according to the number of keywords is not enough, according to him.<br>*<br>So, try another time to search for <b>digestion</b><br>to observe what is new in the ranking.</p>");
define("NEXTOUBLI1","<p class=\"border_red\">A new page has been indexed into the <b>database</b>,<br>thanks to a <b>robot</b> programmed to browse the Web.<br>*<br>But soon the author of the article has claimed <b>right to be forgotten</b>,<br>pending that the person in charge of the website deletes this article.<br>*<br>Which column, in the database, can handle this exception?");
define("NEXTOUBLI2","<br>*<br>What is the name of the page that does not appear in the results?<br><span style='font-size:0.8em;'>(copy from the database)");
define("NEXT2","<p class=\"border_red\">John Smith thinks it is necessary to improve his search engine once more.<br>*<br> So, try another time to search for <b>digestion</b><br>to observe what is new in the ranking.</p>");
define("NEXTALGO","Cooking algorithms:");
define("NEXTALGO1","<table class=\"border_red\"><tr><td colspan='2'>You can compare an algorithm to a recipe for cooking:</td></tr><tr><th>The recipe for cooking:</th><th>The algorithm:</th></tr><tr><td>1. Ingredients and quantities</td><td>1. Entries and data</td></tr><tr><td>2. Recipe steps</td><td>2. Computer instructions</td></tr><tr><td>3. A product: the dish</td><td>3. A product: displaying results</td></tr><tr><td colspan='2'><b>For example:</b><br>&nbsp; <br>1. I have<ul><li>a list of ten webpages (entries);</li><li>with data on each page (title, url, text, number of hits...);</li><li>and calculating the number of words of the lemmas from the keywords in the query.</li></ul>2. Instructions are:<ul><li>retrieve the number of words on each webpage;</li><li>calculate the page rank of each page (adding a score for the lemmas and a score for the hits);</li><li>order webpages from the largest page rank to the smallest;</li><li>for each result, display the title, the beginning of the URL and the beginning of the text.</li></ul>3. The product is the display of results</td></tr><tr><td colspan='2'>The results displayed on the left are proposed from the following statement:<br><span style='font-size:0.8em;'><span style='color:blue;'>&#36;results</span> = <span style='color:blue;'>&#36;bdd</span>->query(<span style='color:green;'>\"SELECT title, url, SUBSTR(url,1,55), SUBSTR(text,1,300) FROM webpages <br>ORDER BY (score_words+score_hits) DESC, score_words DESC\"</span>);</span><br>&nbsp; <br>What addition makes it possible to obtain the page rank?<br>(copy and paste)");
define("NEXTALGO2","<br>&nbsp; <br>How many characters of the URL are displayed in each result?");
define("NEXTALGO3","<br>&nbsp; <br>What does 'DESC' means ?<br><select name=\"algo3\"><option></option><option value=\"ptog\">from the smallest to the largest</option><option value=\"gtop\">from the largest to the smallest</option></select>");
define("NEXTPUB1","<p class=\"border_red\">John Smith could go even further,<br>for example by recording your own navigation to find out what you like.<br>*<br>For now, he just adds <b>advertising</b><br>to earn some money with every click!<br>*<br>What is the term used to recognize advertising?");
define("NEXTPUB2","<br>&nbsp; <br>What kind of website does the advertising link to us?<br><select name=\"pub2\"><option></option><option value=\"jour\">An online journal</option><option value=\"comm\">A commercial website</option><option value=\"ency\">An online encyclopedia</option></select>");
define("NEXTINDEX1","<p class=\"border_red\">The <b>robots</b> of the search engine have discovered a new page.<br>Yet, this page instructs them <b>not to index it</b>.<br>It is registered in the database but without calculation of page rank.<br>*<br> What is the title of this page?");
define("NEXTINDEX2","<br>&nbsp; <br>What is true about this page?<br><span class='index2'>&nbsp;<input type=\"radio\" name=\"index2\" value=\"wiki\" />It is located in the Wikipedia website<br><input type=\"radio\" name=\"index2\" value=\"faux\" />This is a fake article from Wikipedia<br><input type=\"radio\" name=\"index2\" value=\"copy\" />This is a copy of a Wikipedia article</span>");
define("NEXTINDEX3","<br>&nbsp; <br>What is the language used to display this page?");
define("NEXTINDEX4","<br>&nbsp; <br>What is the line of code that tells robots not to index the page?");
define("NEXTINDEX5","<br>&nbsp; <br>Check out this page and its source code by retrieving its URL address<br>and answer the questions below.");
define("NEXTINDEX6","<br>&nbsp; <br>Check out this page and its source code by retrieving its URL address<br>and answer the question below.");

define("RECAP","Let's recap !");
define("RECAP1","What is called the relevance of a webpage?");
define("RECAP2","What is called the popularity of a webpage?");
define("RECAP3","What is called the notoriety of a webpage?");
define("RECAP4","What is called an algorithm ?");
define("RECAP5","What is called a database?");
define("RECAP6","What is called 'right to be forgotten'?");
define("RECAP7","How does indexing work for a search engine?");
define("RECAPREP1","Relevance:");
define("RECAPREP2","Popularity");
define("RECAPREP3","Notoriety:");
define("RECAPREP4","Algorithm:");
define("RECAPREP5","Database:");
define("RECAPREP6","Right to be forgotten:");
define("RECAPREP7","Indexing:");

define("END","3 identical searches, 3 different algorithms, 3 different page ranks ");
?>
